## ros-melodic-robot-state-publisher 1.14.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(robot_state_publisher)

include(CheckCXXCompilerFlag)
unset(COMPILER_SUPPORTS_CXX11 CACHE)
if(MSVC)
  # https://docs.microsoft.com/en-us/cpp/build/reference/std-specify-language-standard-version
  # MSVC will fail the following check since it does not have the c++11 switch
  # however, c++11 is always enabled (the newer /std:c++14 is enabled by default)
  check_cxx_compiler_flag(/std:c++11 COMPILER_SUPPORTS_CXX11)
  if(COMPILER_SUPPORTS_CXX11)
    add_compile_options(/std:c++11)
  endif()

  # MSVC does not support the Wextra flag
  add_compile_options(/Wall)
else()
  check_cxx_compiler_flag(-std=c++11 COMPILER_SUPPORTS_CXX11)
  if(COMPILER_SUPPORTS_CXX11)
    add_compile_options(-std=c++11)
  endif()
  add_compile_options(-Wall -Wextra)
endif()

find_package(orocos_kdl REQUIRED)
find_package(catkin REQUIRED
  COMPONENTS kdl_parser roscpp rosconsole rostime sensor_msgs tf tf2_ros tf2_kdl
)
find_package(Eigen3 REQUIRED)

find_package(urdfdom_headers REQUIRED)

catkin_package(
  LIBRARIES ${PROJECT_NAME}_solver joint_state_listener
  INCLUDE_DIRS include
  DEPENDS kdl_parser orocos_kdl roscpp rosconsole rostime sensor_msgs tf2_ros tf2_kdl urdfdom_headers
)

include_directories(SYSTEM ${EIGEN3_INCLUDE_DIRS})
include_directories(include ${catkin_INCLUDE_DIRS} ${orocos_kdl_INCLUDE_DIRS} ${urdfdom_headers_INCLUDE_DIRS})
link_directories(${orocos_kdl_LIBRARY_DIRS})

add_library(${PROJECT_NAME}_solver
  src/robot_state_publisher.cpp
)
target_link_libraries(${PROJECT_NAME}_solver ${catkin_LIBRARIES} ${orocos_kdl_LIBRARIES})

add_library(joint_state_listener src/joint_state_listener.cpp)
target_link_libraries(joint_state_listener ${PROJECT_NAME}_solver ${orocos_kdl_LIBRARIES})

add_executable(${PROJECT_NAME} src/joint_state_listener.cpp)
target_link_libraries(${PROJECT_NAME} ${PROJECT_NAME}_solver ${orocos_kdl_LIBRARIES})

# compile the same executable using the old name as well
add_executable(state_publisher src/joint_state_listener.cpp)
target_link_libraries(state_publisher ${PROJECT_NAME}_solver ${orocos_kdl_LIBRARIES})

# Tests

if (CATKIN_ENABLE_TESTING)

  find_package(rostest REQUIRED)

  add_rostest_gtest(test_one_link ${CMAKE_CURRENT_SOURCE_DIR}/test/test_one_link.launch test/test_one_link.cpp)
  target_link_libraries(test_one_link ${catkin_LIBRARIES} ${PROJECT_NAME}_solver)

  add_rostest_gtest(test_two_links_fixed_joint ${CMAKE_CURRENT_SOURCE_DIR}/test/test_two_links_fixed_joint.launch test/test_two_links_fixed_joint.cpp)
  target_link_libraries(test_two_links_fixed_joint ${catkin_LIBRARIES} ${PROJECT_NAME}_solver)

  add_rostest_gtest(test_two_links_moving_joint ${CMAKE_CURRENT_SOURCE_DIR}/test/test_two_links_moving_joint.launch test/test_two_links_moving_joint.cpp)
  target_link_libraries(test_two_links_moving_joint ${catkin_LIBRARIES} ${PROJECT_NAME}_solver)

   # Download needed data file
  catkin_download_test_data(
    joint_states_indexed_bag
    http://wiki.ros.org/robot_state_publisher/data?action=AttachFile&do=get&target=joint_states_indexed.bag
    DESTINATION ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_SHARE_DESTINATION}/test
    FILENAME joint_states_indexed.bag
    MD5 793e0b566ebe4698265a936b92fa2bba)

  add_rostest_gtest(test_joint_states_bag ${CMAKE_CURRENT_SOURCE_DIR}/test/test_joint_states_bag.launch test/test_joint_states_bag.cpp)
  target_link_libraries(test_joint_states_bag ${catkin_LIBRARIES} ${PROJECT_NAME}_solver)

  add_rostest_gtest(test_subclass ${CMAKE_CURRENT_SOURCE_DIR}/test/test_subclass.launch test/test_subclass.cpp)
  target_link_libraries(test_subclass ${catkin_LIBRARIES} ${PROJECT_NAME}_solver joint_state_listener)

  install(FILES test/one_link.urdf test/pr2.urdf test/two_links_fixed_joint.urdf test/two_links_moving_joint.urdf DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/test)

endif()

# Install library
install(TARGETS ${PROJECT_NAME}_solver joint_state_listener
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

# Install executable
install(TARGETS ${PROJECT_NAME} state_publisher
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

=== debian/changelog ===
ros-melodic-robot-state-publisher (1.14.1-1bionic) bionic; urgency=high

  * Bump CMake version to avoid CMP0048 warning (#132 <https://github.com/ros/robot_state_publisher/issues/132>)
  * Make sure to make sensor_msgs a catkin dependency. (#123 <https://github.com/ros/robot_state_publisher/issues/123>)
  * Add joint_state_listener to the catkin package LIBRARIES (#112 <https://github.com/ros/robot_state_publisher/issues/112>)
  * Contributors: Alejandro Hernández Cordero, Chris Lalancette, sevangelatos

 -- Chris Lalancette <clalancette@osrfoundation.org>  Thu, 02 Apr 2020 00:00:00 -0000

ros-melodic-robot-state-publisher (1.14.0-1bionic) bionic; urgency=high

  * Revert "Remove dependency on tf and tf_prefix support (#82 <https://github.com/ros/robot_state_publisher/issues/82>)" (#113 <https://github.com/ros/robot_state_publisher/issues/113>)
  * update how compiler flags are added (#104 <https://github.com/ros/robot_state_publisher/issues/104>)
  * update install destination in CMakeLists.txt (#103 <https://github.com/ros/robot_state_publisher/issues/103>)
  * Remove treefksolver completely from the repository. (#100 <https://github.com/ros/robot_state_publisher/issues/100>)
  * changed return code from -1 to 1 since its considered a reserved bash exit code (#98 <https://github.com/ros/robot_state_publisher/issues/98>)
  * Fixed problem when building static library version (#92 <https://github.com/ros/robot_state_publisher/issues/92>) (#96 <https://github.com/ros/robot_state_publisher/issues/96>)
  * Add Ian as a maintainer for robot_state_publisher. (#94 <https://github.com/ros/robot_state_publisher/issues/94>)
  * added warning when joint is found in joint message but not in the urdf (#83 <https://github.com/ros/robot_state_publisher/issues/83>)
  * added ros_warn if JointStateMessage is older than 30 seconds (#84 <https://github.com/ros/robot_state_publisher/issues/84>)
  * Add tcp_no_delay to joint_states subscriber (#80 <https://github.com/ros/robot_state_publisher/issues/80>) (#85 <https://github.com/ros/robot_state_publisher/issues/85>)
  * Remove dependency on tf and tf_prefix support (#82 <https://github.com/ros/robot_state_publisher/issues/82>)
  * make rostest in CMakeLists optional (ros/rosdistro#3010 <https://github.com/ros/rosdistro/issues/3010>) (#75 <https://github.com/ros/robot_state_publisher/issues/75>)
  * Added c++11 target_compile_options (#78 <https://github.com/ros/robot_state_publisher/issues/78>)
  * Contributors: Chris Lalancette, James Xu, Lukas Bulwahn, Shane Loretz, betab0t, jgueldenstein

 -- Chris Lalancette <clalancette@osrfoundation.org>  Tue, 27 Aug 2019 00:00:00 -0000

ros-melodic-robot-state-publisher (1.13.5-1bionic) bionic; urgency=high

  * Style cleanup throughout the tree.
  * add Chris and Shane as maintainers (#70 <https://github.com/ros/robot_state_publisher/issues/70>)
  * Contributors: Chris Lalancette, William Woodall

 -- Chris Lalancette <clalancette@osrfoundation.org>  Tue, 11 Apr 2017 00:00:00 -0000

ros-melodic-robot-state-publisher (1.13.4-1bionic) bionic; urgency=high

  * Use ``urdf::*ShredPtr`` instead of ``boost::shared_ptr`` (#60 <https://github.com/ros/robot_state_publisher/issues/60>)
  * Error log for empty JointState.position was downgraded to a throttled warning (#64 <https://github.com/ros/robot_state_publisher/issues/64>)
  * Contributors: Jochen Sprickerhof, Sébastien BARTHÉLÉMY

 -- Chris Lalancette <clalancette@osrfoundation.org>  Thu, 05 Jan 2017 00:00:00 -0000

ros-melodic-robot-state-publisher (1.13.3-1bionic) bionic; urgency=high

  * Added a new parameter "ignore_timestamp" (#65 <https://github.com/ros/robot_state_publisher/issues/65>)
  * Fixed joints are not published over tf_static by default (#56 <https://github.com/ros/robot_state_publisher/issues/56>)
  * Fixed segfault on undefined robot_description (#61 <https://github.com/ros/robot_state_publisher/issues/61>)
  * Fixed cmake eigen3 warning (#62 <https://github.com/ros/robot_state_publisher/issues/62>)
  * Contributors: Davide Faconti, Ioan A Sucan, Johannes Meyer, Robert Haschke

 -- Chris Lalancette <clalancette@osrfoundation.org>  Thu, 20 Oct 2016 00:00:00 -0000

ros-melodic-robot-state-publisher (1.13.2-1bionic) bionic; urgency=high

  * Add target_link_libraries for joint_state_listener library + install it (#54 <https://github.com/ros/robot_state_publisher//issues/54>)
  * Contributors: Kartik Mohta

 -- Chris Lalancette <clalancette@osrfoundation.org>  Fri, 10 Jun 2016 00:00:00 -0000

ros-melodic-robot-state-publisher (1.13.1-1bionic) bionic; urgency=high

  * Add back future dating for robot_state_publisher (#49 <https://github.com/ros/robot_state_publisher/issues/49>) (#51 <https://github.com/ros/robot_state_publisher/issues/51>)
  * Fix subclassing test (#48 <https://github.com/ros/robot_state_publisher/issues/48>)
  * Support for subclassing (#45 <https://github.com/ros/robot_state_publisher/issues/45>)
    * Add joint_state_listener as a library
  * Contributors: Jackie Kay

 -- Chris Lalancette <clalancette@osrfoundation.org>  Fri, 20 May 2016 00:00:00 -0000

ros-melodic-robot-state-publisher (1.13.0-1bionic) bionic; urgency=high

  * fix bad rebase
  * Contributors: Jackie Kay, Paul Bovbel

 -- Chris Lalancette <clalancette@osrfoundation.org>  Tue, 12 Apr 2016 00:00:00 -0000

ros-melodic-robot-state-publisher (1.12.1-1bionic) bionic; urgency=high

  * Merge pull request #42 <https://github.com/ros/robot_state_publisher/issues/42> from ros/fix_tests_jade
    Fix tests for Jade
  * Correct failing tests
  * Re-enabling rostests
  * Merge pull request #39 <https://github.com/ros/robot_state_publisher/issues/39> from scpeters/issue_38
  * Fix API break in publishFixedTransforms
    A bool argument was added to
    RobotStatePublisher::publishFixedTransforms
    which broke API.
    I've added a default value of false, to match
    the default specified in the JointStateListener
    constructor.


=== debian/control ===
Source: ros-melodic-robot-state-publisher
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, liburdfdom-headers-dev, ros-melodic-catkin, ros-melodic-kdl-parser, ros-melodic-orocos-kdl (>= 1.3.0), ros-melodic-rosconsole, ros-melodic-roscpp, ros-melodic-rostest, ros-melodic-rostime, ros-melodic-sensor-msgs, ros-melodic-tf, ros-melodic-tf2-kdl, ros-melodic-tf2-ros
Homepage: http://wiki.ros.org/robot_state_publisher
Standards-Version: 3.9.2

Package: ros-melodic-robot-state-publisher
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-melodic-catkin, ros-melodic-kdl-parser, ros-melodic-orocos-kdl (>= 1.3.0), ros-melodic-rosconsole, ros-melodic-roscpp, ros-melodic-rostime, ros-melodic-sensor-msgs, ros-melodic-tf, ros-melodic-tf2-kdl, ros-melodic-tf2-ros
Description: This package allows you to publish the state of a robot to tf.
 Once the state gets published, it is available to all components in the system that also use tf. The package takes the joint angles of the robot as input and publishes the 3D poses of the robot links, using a kinematic tree model of the robot. The package can both be used as a library and as a ROS node. This package has been well tested and the code is stable. No major changes are planned in the near future.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-robot-state-publisher//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
